<?php
define('VERSION', 'v2.7.1');
error_reporting(NULL);
/**
 *
 * FileGator
 *
 * Copyright  2011-2012 by interactive32. All right reserved.
 * Designed & developed by alcalbg. Logo design by batabarata.
 * This software uses open-source plugins blueimp, foundation, lightbox and jquery.
 * For more info please visit gator's web page www.20script.ir
 *
 *
 * This file contains all the configuration options
 *
 *
 */

class gatorconf {

	/**
	 *
	 * Configuration options
	 *
	 * You may need to logout/login for some changes to take effect
	 *
	 * Make sure Apache service has read/write access to the repository folder(s)
	 *
	 * NOTICE: Current .htaccess file inside repository directory will prevent script and html execution inside that directory
	 *
	 */
	public static function get($param) {

		$config = array(

		// user config storage file
		'user_config_file' => getcwd().'/config/config.json',

		// main file repository
		// this is also a repository for users without specific homedir
		// you'll need to make sure your webserver can write here
		'repository' => getcwd().'/repository',
		
		// mask directories up to the main file repository (true/false)
		// set this to true if you don't want to use full path iside admin area
		'mask_repository_path' => false,
		
		// allow guest account (true/false)
		'allow_guests' => false,

		// allow clickable links on files (true/false)
		// set to false if repository is not inside server's public directory
		'allow_file_links' => true,

		// use lightbox plugin to preview images (true/false)
		// this also enables allow_file_links
		'use_lightbox_gallery' => true,

		// accepted file types when uploading or '*' for no restrictions
		// example: 'accept_file_extensions' => array('gif','jpg','jpeg','png'),
		'accept_file_extensions' => array('*'),

		// max number of files on batch upload
		'max_files' => 100,

		// maximum file size in bytes when uploading
		// The php.ini settings upload_max_filesize and post_max_size
		// take precedence over the following setting
		'max_filesize' => 2097152, // 2MB

		// time/date format - see php date()
		'time_format' => 'd/m/y',

		// use simple copy-move instead of cut-copy-paste (true/false)
		'simple_copy_move' => true,

		// use zip functions (true/false)
		// zip extension must be enabled on server (see http://php.net/manual/en/book.zip.php)
		'use_zip' => true,

		// files can be edited (true/false)
		'allow_edit_files' => true,

		// files/folders can be renamed (true/false)
		'allow_rename_files' => true,

		// show top-bar (true/false)
		'show_top_auth_bar' => true,
				
		// users can change their password (true/false)
		'allow_change_password' => false,
				
		// this restricted files will be hidden (no wildcards)
		'restricted_files' => array('.htaccess'),

		// encrypt url actions (true/false)
		'encrypt_url_actions' => false,
		
		// allow links to be sent via email (true/false)
		'allow_email_links' => false,		
		'mail_subject' => 'File for you',
		
		// Use goo.gl URL shortener (true/false). This requires cURL php support.
		'use_googl_shorturl' => false,
		// get goo.gl API key from: http://code.google.com/apis/console/
		'googl_shorturl_api_key' => '123456789',
		
		// use advanced smtp mail protocol (true/false)
		'use_smtp_protocol' => false,
		'mail_smtp_from' => 'info@example.com',
		'mail_smtp_from_name' => 'info',
		'mail_smtp_host' => 'smtp.example.com:25',
		'mail_smtp_username' => 'info@example.com',
		'mail_smtp_password' => 'mypassword',
		'mail_smtp_connection_security' => 'tls', // 'tls', 'ssl' or '' for no security
		'mail_smtp_debug' => false,
		
		// use authentication module (true/false)
		// WARNING: if you set this to false anyone can see, change or delete your files without need to login
		// this will also disable encrypt_url_actions
		'use_auth' => true,

		// server url and base path, usually you don't need to change this
		'base_url' => 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']),
		'base_path' => getcwd(),

		// write user actions to usage.log file (true/false)
		'write_log' => false,

		);

		/**
		 *
		 * End of configuration options
		 *
		 */

		// load users database on start and on file change
		if (!isset($_SESSION['cached_users']) || $_SESSION['user_config_stamp'] != filemtime($config['user_config_file'])){
			$_SESSION['user_config_stamp'] = filemtime($config['user_config_file']);
			$_SESSION['cached_users'] = json_decode(file_get_contents($config['user_config_file']), true);
			
			// refresh user's permissions
			if (isset($_SESSION['simple_auth']['permissions'])){
				foreach ($_SESSION['cached_users'] as $user) {
					// account match
					if ($user['username'] == $_SESSION['simple_auth']['username']){
						$_SESSION['simple_auth']['permissions'] = $user['permissions'];
					}
				}
			}

		}
		
		$config['users'] = $_SESSION['cached_users'];

		$config['base_path'] = str_replace('\\', '/', $config['base_path']);
		if ($param != 'base_path') $config = gator::validateConf($config, $param);
		
		return $config[$param];
	}

}


// start session & handle logout
session_start();
if(isset($_GET["logout"]) && $_GET["logout"] == 1){
	session_destroy();
	session_start();
}

require_once gatorconf::get('base_path')."/include/file-gator.php";
new gator();
